/*
 * $Id: Exception.java,v 1.5 2007/06/29 11:36:45 bacon Exp $
 *
 * {License}
 */

package ase.awk;

public class Exception extends java.lang.Exception
{
	private int code;
	private int line;

	// generated by generrcode-java.awk
	public static final int NOERR = 0;
	public static final int INVAL = 1;
	public static final int NOMEM = 2;
	public static final int NOSUP = 3;
	public static final int NOPER = 4;
	public static final int NODEV = 5;
	public static final int NOSPC = 6;
	public static final int MFILE = 7;
	public static final int MLINK = 8;
	public static final int AGAIN = 9;
	public static final int NOENT = 10;
	public static final int EXIST = 11;
	public static final int FTBIG = 12;
	public static final int TBUSY = 13;
	public static final int ISDIR = 14;
	public static final int IOERR = 15;
	public static final int OPEN = 16;
	public static final int READ = 17;
	public static final int WRITE = 18;
	public static final int CLOSE = 19;
	public static final int INTERN = 20;
	public static final int RUNTIME = 21;
	public static final int BLKNST = 22;
	public static final int EXPRNST = 23;
	public static final int SINOP = 24;
	public static final int SINCL = 25;
	public static final int SINRD = 26;
	public static final int SOUTOP = 27;
	public static final int SOUTCL = 28;
	public static final int SOUTWR = 29;
	public static final int LXCHR = 30;
	public static final int LXDIG = 31;
	public static final int LXUNG = 32;
	public static final int ENDSRC = 33;
	public static final int ENDCMT = 34;
	public static final int ENDSTR = 35;
	public static final int ENDREX = 36;
	public static final int LBRACE = 37;
	public static final int LPAREN = 38;
	public static final int RPAREN = 39;
	public static final int RBRACK = 40;
	public static final int COMMA = 41;
	public static final int SCOLON = 42;
	public static final int COLON = 43;
	public static final int STMEND = 44;
	public static final int IN = 45;
	public static final int NOTVAR = 46;
	public static final int EXPRES = 47;
	public static final int WHILE = 48;
	public static final int ASSIGN = 49;
	public static final int IDENT = 50;
	public static final int FNNAME = 51;
	public static final int BLKBEG = 52;
	public static final int BLKEND = 53;
	public static final int DUPBEG = 54;
	public static final int DUPEND = 55;
	public static final int BFNRED = 56;
	public static final int AFNRED = 57;
	public static final int GBLRED = 58;
	public static final int PARRED = 59;
	public static final int DUPPAR = 60;
	public static final int DUPGBL = 61;
	public static final int DUPLCL = 62;
	public static final int BADPAR = 63;
	public static final int BADVAR = 64;
	public static final int UNDEF = 65;
	public static final int LVALUE = 66;
	public static final int GBLTM = 67;
	public static final int LCLTM = 68;
	public static final int PARTM = 69;
	public static final int DELETE = 70;
	public static final int BREAK = 71;
	public static final int CONTINUE = 72;
	public static final int NEXTBEG = 73;
	public static final int NEXTEND = 74;
	public static final int NEXTFBEG = 75;
	public static final int NEXTFEND = 76;
	public static final int PRINTFARG = 77;
	public static final int PREPST = 78;
	public static final int GLNCPS = 79;
	public static final int DIVBY0 = 80;
	public static final int OPERAND = 81;
	public static final int POSIDX = 82;
	public static final int ARGTF = 83;
	public static final int ARGTM = 84;
	public static final int FNNONE = 85;
	public static final int NOTIDX = 86;
	public static final int NOTDEL = 87;
	public static final int NOTMAP = 88;
	public static final int NOTMAPIN = 89;
	public static final int NOTMAPNILIN = 90;
	public static final int NOTREF = 91;
	public static final int NOTASS = 92;
	public static final int IDXVALASSMAP = 93;
	public static final int POSVALASSMAP = 94;
	public static final int MAPTOSCALAR = 95;
	public static final int SCALARTOMAP = 96;
	public static final int MAPNOTALLOWED = 97;
	public static final int VALTYPE = 98;
	public static final int RDELETE = 99;
	public static final int RNEXTBEG = 100;
	public static final int RNEXTEND = 101;
	public static final int RNEXTFBEG = 102;
	public static final int RNEXTFEND = 103;
	public static final int BFNUSER = 104;
	public static final int BFNIMPL = 105;
	public static final int IOUSER = 106;
	public static final int IONONE = 107;
	public static final int IOIMPL = 108;
	public static final int IONMEM = 109;
	public static final int IONMNL = 110;
	public static final int FMTARG = 111;
	public static final int FMTCNV = 112;
	public static final int CONVFMTCHR = 113;
	public static final int OFMTCHR = 114;
	public static final int REXRECUR = 115;
	public static final int REXRPAREN = 116;
	public static final int REXRBRACKET = 117;
	public static final int REXRBRACE = 118;
	public static final int REXUNBALPAR = 119;
	public static final int REXCOLON = 120;
	public static final int REXCRANGE = 121;
	public static final int REXCCLASS = 122;
	public static final int REXBRANGE = 123;
	public static final int REXEND = 124;
	public static final int REXGARBAGE = 125;
	// end of error codes

	public Exception () 
	{
		super ();
		this.code = NOERR;
		this.line = 0;
	}

	public Exception (String msg)
	{
		super (msg);
		this.code = NOERR;
		this.line = 0;
	}

	public Exception (String msg, int code)
	{
		super (msg);
		this.code = code;
		this.line = 0;
	}

	public Exception (String msg, int code, int line)
	{
		super (msg);
		this.code = code;
		this.line = line;
	}

	public int getCode ()
	{
		return this.code;
	}

	public int getLine ()
	{
		return this.line;
	}
}
